function save() {
  var name = $('#form-preset-name').val();
  ruby.call('save_preset', [name])
    .done( closeOnSaveSuccess );
}

function cancel() {
  if (ruby.isHtmlDialog) {
    window.close();
  } else {
    ruby.call('close');
  }
}

function closeOnSaveSuccess() {
  model.fetchData()
    .done(function() {
      if (model.data.callbackStatus) {
        if (ruby.isHtmlDialog) {
          window.close();
        } else {
          ruby.call('close');
        }
      }
    });
}

function isSpecialKey(keyCode) {
  var isSpecial = keyCode === 13 || //ENTER
                  keyCode === 27 || // ESC
                  keyCode === 8;    // BACKSPACE
  return isSpecial;
}

var invalidNameChars = [
  '/', '?', '<', '>', '\\',
  ':', '*', '|', '"', '.'
];

function isValidNameCharacter(chr) {
  var isValid = invalidNameChars.indexOf(chr) < 0;
  return isValid;
}

var view = new View({
  'filterKeys': true,
  'contextMenuOff': true,
  'keyActions': {
    // ENTER
    13: save,
    // ESC
    27: cancel
  }
});

view.addHook('render', function() {
  $('#form-preset-name').select();
});

view.on('click', '#btn-save', function() {
  save();
});

view.on('click', '#btn-cancel', function() {
  cancel();
});

view.on('keypress', '#form-preset-name', function(ev) {
  var keyPressed = String.fromCharCode(ev.keyCode);
  if (!isSpecialKey(ev.keyCode) && !isValidNameCharacter(keyPressed)) {
    return false;
  }
});

view.refresh();
