if (ruby.debug) { // DEBUG
  window.open = function (_) { //DEBUG
    return window; //DEBUG
  }; //DEBUG
} // DEBUG

var app;
var elmFlags;

if (Elm.DialogView.init) {
  // Elm v19
  app = Elm.DialogView.init({
    node: document.getElementById('elm-node'),
    flags: elmFlags
  });
} else {
  // Elm v18
  app = Elm.DialogView.fullscreen();
}

if (app.ports.fetchDataSerialized) {
  app.ports.fetchDataSerialized.subscribe(function () {
    model.fetchData()
      .done(function () {
        app.ports.data.send(model.data);
      });
  });
}

if (app.ports.callSerialized) {
  app.ports.callSerialized.subscribe(function (cbInfoStr) {
    var cbInfo = JSON.parse(cbInfoStr);
    var funName = cbInfo.shift();
    var agrs = cbInfo;
    ruby.send(funName, agrs)
      .done(function () {
        app.ports.callDone.send(funName);
      });
  });
}

// Making a dummy 'view' object for easy dialog refreshing from ruby
var view = {
  refresh: function () {
    model.fetchData()
      .done(function () {
        if (app.ports.data) {
          app.ports.data.send(model.data);
        }
      });
  }
};
